unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  users_basic, users_CS, Db, DBTables, Menus, StdCtrls, users_ibx,
  IBDatabase;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    UsersIBX1: TUsersIBX;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    UsersIBXReg1: TUsersIBXReg;
    procedure FormCreate(Sender: TObject);
    procedure UsersIBX1AddComponentsAtRunTime;
    procedure dbUsersBeforeConnect(Sender: TObject);
  private
    { Private declarations }
    procedure ChangeUserPassword(Sender: TObject);
    procedure UserAdministration(Sender: TObject);
    procedure Login(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  MenuItemParent, MenuItem: TMenuItem;
begin
  MenuItemParent:=TMenuItem.Create(MainMenu1);
  MenuItemParent.Name:='Customer';
  MenuItemParent.Caption:='Customer';
  MainMenu1.Items.Add(MenuItemParent);

  MenuItem:=TMenuItem.Create(MainMenu1);
  MenuItem.Name:='Add';
  MenuItem.Caption:='Add';
  MenuItemParent.Add(MenuItem);

  MenuItem:=TMenuItem.Create(MainMenu1);
  MenuItem.Name:='Edit';
  MenuItem.Caption:='Edit';
  MenuItemParent.Add(MenuItem);

  MenuItem:=TMenuItem.Create(MainMenu1);
  MenuItem.Name:='List';
  MenuItem.Caption:='List';
  MenuItemParent.Add(MenuItem);

  MenuItemParent:=TMenuItem.Create(MainMenu1);
  MenuItemParent.Name:='Security';
  MenuItemParent.Caption:='Security';
  MainMenu1.Items.Add(MenuItemParent);

  MenuItem:=TMenuItem.Create(MainMenu1);
  MenuItem.Name:='UserAdm';
  MenuItem.Caption:='User Administration';
  MenuItem.OnClick:=UserAdministration;
  MenuItemParent.Add(MenuItem);

  MenuItem:=TMenuItem.Create(MainMenu1);
  MenuItem.Name:='ChangePwd';
  MenuItem.Caption:='Change Password';
  MenuItem.OnClick:=ChangeUserPassword;
  MenuItemParent.Add(MenuItem);

  MenuItem:=TMenuItem.Create(MainMenu1);
  MenuItem.Name:='Login';
  MenuItem.Caption:='Login';
  MenuItem.OnClick:=Login;
  MenuItemParent.Add(MenuItem);
  // * in order to add componenst at runtime, the AutoLogin must be false
  //   the login method must be called by the developer, so you are able to
  //   add your run-time components before the component updates the
  //   security database.
  Login(Sender);
  // * the code above executes the Login procedure, which calls the
  //   component login method.
end;

procedure TForm1.ChangeUserPassword(Sender: TObject);
begin
  UsersIBX1.ChangeUserPassword;
end;

procedure TForm1.UserAdministration(Sender: TObject);
begin
  UsersIBX1.UsersAdm;
end;

procedure TForm1.Login(Sender: TObject);
begin
  if not UsersIBX1.Login then
    Application.Terminate;
end;

procedure TForm1.UsersIBX1AddComponentsAtRunTime;
var
  i,j: Integer;

function ExtractChar(Str: String;Chr: Char): String;
var
  i: Integer;
begin
  Result:='';
  for i:=1 to Length(Str) do
    if Str[i]<>Chr then
      Result:=Result+Str[i];
end;

begin
  // AddComponentAtRunTime(FormName, ComponentName, ComponentCaption, ComponentParent: String);
  UsersIBX1.AddComponentsAtRunTime(Form1.Name,MainMenu1.Name,'Menu',Form1.Name);
  for i:=0 to MainMenu1.Items.Count-1 do
    begin
      UsersIBX1.AddComponentsAtRunTime(Form1.Name,MainMenu1.Items[i].Name, ExtractChar(MainMenu1.Items[i].Caption,'&'), MainMenu1.Name);
      for j:=0 to MainMenu1.Items[i].Count-1 do
        UsersIBX1.AddComponentsAtRunTime(Form1.Name,MainMenu1.Items[i].Items[j].Name, ExtractChar(MainMenu1.Items[i].Items[j].Caption,'&'), MainMenu1.Items[i].Name);
    end
end;

procedure TForm1.dbUsersBeforeConnect(Sender: TObject);
begin
//  IBDatabase1.Params.Values['PATH']:=ExtractFilePath(Application.ExeName);
  IBDatabase1.Params.Values['PATH']:=ExtractFilePath(Application.ExeName)+'..\Data';
end;

end.
