unit frmUserInformationU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IBServices, StdCtrls, ActnList;

type
  TfrmUserInformation = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edtConfirmPassword: TEdit;
    edtPassword: TEdit;
    edtUser: TEdit;
    Label4: TLabel;
    edtFirstName: TEdit;
    Label5: TLabel;
    edtMiddleName: TEdit;
    Label6: TLabel;
    edtLastName: TEdit;
    btnOk: TButton;
    btnCancel: TButton;
    ActionList1: TActionList;
    Ok: TAction;
    procedure FormCreate(Sender: TObject);
    procedure OkUpdate(Sender: TObject);
    procedure OkExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure RetrieveInfo;
  public
    IBSecurityService1: TIBSecurityService;
    procedure DisplayUser(UserName : String);
    { Public declarations }
  end;

var
  frmUserInformation: TfrmUserInformation;

implementation

uses frmAdminToolU;

{$R *.DFM}

{ TfrmUserInformation }

procedure TfrmUserInformation.DisplayUser(UserName: String);
begin
  IBSecurityService1.Active := true;
  try
    if UserName <> '' then
    begin
      IBSecurityService1.DisplayUser(UserName);
      edtUser.Text := IBSecurityService1.UserInfo[0].UserName;
      edtUser.ReadOnly := true;
      edtPassword.Text := '';
      edtConfirmPassword.Text := '';
      edtFirstName.Text := IBSecurityService1.UserInfo[0].FirstName;
      edtMiddleName.Text := IBSecurityService1.UserInfo[0].MiddleName;
      edtLastName.Text := IBSecurityService1.UserInfo[0].LastName;
      IBSecurityService1.SecurityAction := ActionModifyUser;
    end
    else
    begin
      edtUser.Text := '';
      edtUser.ReadOnly := false;
      edtPassword.Text := '';
      edtConfirmPassword.Text := '';
      edtFirstName.Text := '';
      edtMiddleName.Text := '';
      edtLastName.Text := '';
      IBSecurityService1.SecurityAction := ActionAddUser;
    end;
  finally
    IBSecurityService1.Active := false;
  end;
end;

procedure TfrmUserInformation.RetrieveInfo;
begin
  if edtPassword.Text <> edtConfirmPassword.Text then
    raise Exception.Create('Passwords do not match');
  with IBSecurityService1 do
  begin
    UserName := edtUser.Text;
    Password := edtPassword.Text;
    FirstName := edtFirstName.Text;
    MiddleName := edtMiddleName.Text;
    LastName := edtLastName.Text;
  end;
end;

procedure TfrmUserInformation.FormCreate(Sender: TObject);
begin
  IBSecurityService1 := frmAdminTool.IBSecurityService1;
end;

procedure TfrmUserInformation.OkUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := (edtPassword.Text = edtConfirmPassword.Text) and
    (edtPassword.Modified or edtConfirmPassword.Modified) and
    (edtUser.Text <> '');
end;

procedure TfrmUserInformation.OkExecute(Sender: TObject);
begin
  RetrieveInfo;
  IBSecurityService1.Active := true;
  if IBSecurityService1.SecurityAction = ActionAddUser then
    IBSecurityService1.AddUser
  else
    IBSecurityService1.ModifyUser;
  IBSecurityService1.Active := false;
end;

procedure TfrmUserInformation.FormShow(Sender: TObject);
begin
  if edtUser.Text = '' then
    frmUserInformation.edtUser.SetFocus
  else
    frmUserInformation.edtPassword.SetFocus;
end;

end.
